Object subclass: #Clause
	instanceVariableNames: 'string phrases accent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!
!Clause commentStamp: '<historical>' prior: 0!
My instances are clauses. They can carry a phrase accent (applicable to their last phrase) and a boundary tone: 'L- L%' (for declarative sentences in American English), 'H- H%' (for Yes-No questions), etc.!


!Clause methodsFor: 'accessing' stamp: 'len 12/12/1999 22:46'!
accent
	^ accent! !

!Clause methodsFor: 'accessing' stamp: 'len 12/12/1999 22:46'!
accent: aString
	accent _ aString! !

!Clause methodsFor: 'accessing' stamp: 'len 12/13/1999 02:32'!
accept: anObject
	anObject clause: self! !

!Clause methodsFor: 'accessing' stamp: 'len 12/8/1999 17:53'!
events
	| answer |
	answer _ CompositeEvent new.
	self phrases do: [ :each | answer addAll: each events].
	^ answer! !

!Clause methodsFor: 'accessing' stamp: 'len 12/8/1999 17:50'!
lastSyllable
	^ self phrases last lastSyllable! !

!Clause methodsFor: 'accessing' stamp: 'len 12/8/1999 17:49'!
phrases
	^ phrases! !

!Clause methodsFor: 'accessing' stamp: 'len 12/8/1999 17:50'!
phrases: aCollection
	phrases _ aCollection! !

!Clause methodsFor: 'accessing' stamp: 'len 12/12/1999 22:22'!
string
	^ string! !

!Clause methodsFor: 'accessing' stamp: 'len 12/12/1999 22:22'!
string: aString
	string _ aString! !


!Clause methodsFor: 'enumarating' stamp: 'len 12/13/1999 01:19'!
eventsDo: aBlock
	self phrases do: [ :phrase | phrase eventsDo: aBlock]! !

!Clause methodsFor: 'enumarating' stamp: 'len 12/14/1999 04:22'!
syllablesDo: aBlock
	self wordsDo: [ :each | each syllables do: aBlock]! !

!Clause methodsFor: 'enumarating' stamp: 'len 12/13/1999 02:40'!
wordsDo: aBlock
	self phrases do: [ :each | each words do: aBlock]! !


!Clause methodsFor: 'printing' stamp: 'len 12/8/1999 18:17'!
printOn: aStream
	self phrases do: [ :each | aStream print: each; nextPutAll: '- ']! !


Object subclass: #Phrase
	instanceVariableNames: 'string words accent '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!
!Phrase commentStamp: '<historical>' prior: 0!
My instances are phrases. They can carry a phrase accent ('H-' or 'L-') and a boundary tone ('H%', 'L%', '%H').!


!Phrase methodsFor: 'accessing' stamp: 'len 12/12/1999 22:32'!
accent
	^ accent! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/12/1999 22:32'!
accent: aString
	accent _ aString! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/8/1999 17:48'!
accept: anObject
	anObject phrase: self! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/8/1999 17:53'!
events
	| answer |
	answer _ CompositeEvent new.
	self words do: [ :each | answer addAll: each events].
	^ answer! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/8/1999 18:51'!
lastSyllable
	^ self words last lastSyllable! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/12/1999 22:22'!
string
	^ string! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/12/1999 22:22'!
string: aString
	string _ aString! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/8/1999 17:47'!
words
	^ words! !

!Phrase methodsFor: 'accessing' stamp: 'len 12/8/1999 17:48'!
words: aCollection
	words _ aCollection! !


!Phrase methodsFor: 'enumarating' stamp: 'len 12/13/1999 01:19'!
eventsDo: aBlock
	self words do: [ :word | word eventsDo: aBlock]! !

!Phrase methodsFor: 'enumarating' stamp: 'len 12/13/1999 02:37'!
syllablesDo: aBlock
	self words do: [ :each | each syllables do: aBlock]! !


!Phrase methodsFor: 'printing' stamp: 'len 12/8/1999 18:17'!
printOn: aStream
	self words do: [ :each | aStream print: each; space]! !


Object subclass: #Speaker
	instanceVariableNames: 'pitch range loudness speed transcriber voice visitors '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!

!Speaker methodsFor: 'initialization' stamp: 'len 11/27/2000 09:59'!
initialize
	self pitch: 100.0; range: 0.3; loudness: 1.0; speed: 0.6; "normalizer: TextNormalizer new;" transcriber: PhoneticTranscriber default; visitors: {IntonationVisitor default. DurationsVisitor default. F0RenderingVisitor default}! !


!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:33'!
loudness
	^ loudness! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:33'!
loudness: aNumber
	loudness _ aNumber! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/13/1999 03:02'!
phonemes
	"Answer the phoneme set of the receiver."
	^ self transcriber phonemes! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/12/1999 23:18'!
pitch
	"Answer the average pitch."
	^ pitch! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/12/1999 23:18'!
pitch: aNumber
	"Set the average pitch."
	pitch _ aNumber! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/12/1999 23:18'!
range
	"Answer the pitch range (variation)."
	^ range! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/13/1999 01:14'!
range: aNumber
	"Set the pitch range (variation)."
	range _ aNumber! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:33'!
speed
	^ speed! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:33'!
speed: aNumber
	speed _ aNumber! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:31'!
transcriber
	^ transcriber! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:31'!
transcriber: aPhoneticTranscriber
	transcriber _ aPhoneticTranscriber! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/12/1999 23:02'!
visitors
	^ visitors! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/12/1999 23:02'!
visitors: aCollection
	visitors _ aCollection! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:32'!
voice
	^ voice! !

!Speaker methodsFor: 'accessing' stamp: 'len 12/8/1999 16:32'!
voice: aVoice
	voice _ aVoice! !


!Speaker methodsFor: 'parsing' stamp: 'len 12/14/1999 02:13'!
clauseFromString: aString
	^ Clause new
		string: aString;
		phrases: ((aString findTokens: '!!?.,;()') collect: [ :each | self phraseFromString: each])! !

!Speaker methodsFor: 'parsing' stamp: 'len 12/22/1999 03:46'!
eventsFromString: aString
	| clause |
	clause _ self clauseFromString: aString.
	clause phrases do: [ :each | each lastSyllable events add: (PhoneticEvent new phoneme: self phonemes silence; duration: 0.1)].
	clause lastSyllable events last duration: 0.5.
	visitors do: [ :each | each speaker: self. clause accept: each].
	clause eventsDo: [ :each | each loudness: self loudness].
	^ clause events! !

!Speaker methodsFor: 'parsing' stamp: 'len 12/13/1999 03:19'!
phraseFromString: aString
	^ Phrase new
		string: aString;
		words: ((aString findTokens: ' !!?.,;()') collect: [ :each | self wordFromString: each])! !

!Speaker methodsFor: 'parsing' stamp: 'len 12/8/1999 17:08'!
syllabizationOf: phonemes
	| syllable stream last answer |
	answer _ OrderedCollection new.
	syllable _ Syllable new phonemes: (OrderedCollection new: 4).
	stream _ ReadStream on: phonemes.
	[stream atEnd]
		whileFalse: [syllable phonemes add: (last _ stream next).
					(stream atEnd not and: [last isConsonant not and: [stream peek isConsonant]])
						ifTrue: [answer add: syllable. syllable _ Syllable new phonemes: (OrderedCollection new: 4)]].
	syllable phonemes isEmpty ifFalse: [answer add: syllable].
	^ answer! !

!Speaker methodsFor: 'parsing' stamp: 'len 12/8/1999 18:24'!
wordFromString: aString
	^ Word new
		string: aString;
		syllables: (self syllabizationOf: (self transcriber transcriptionOf: aString))! !


!Speaker methodsFor: 'playing' stamp: 'di 8/25/2001 16:00'!
say: aString
	| events stream string |
	events _ CompositeEvent new.
	stream _ ReadStream on: ((aString copyReplaceAll: '-' with: ' ' asTokens: false)
								findTokens: '?' keep: '?').
	[stream atEnd]
		whileFalse: [string _ stream next.
					stream atEnd ifFalse: [string _ string, stream next].
					events addAll: (self eventsFromString: string)].
	events playOn: self voice delayed: events duration * 1000.
	self voice flush! !


!Speaker methodsFor: 'editing' stamp: 'ar 11/9/2000 20:57'!
edit
	| answer buttons |
	answer _ (self findAVoice: KlattVoice) editor.
	buttons _ AlignmentMorph new listDirection: #leftToRight; color: answer color.
	buttons
		addMorphFront: (SimpleButtonMorph new target: self; actWhen: #buttonDown; actionSelector:  #newHead; labelString: 'new head');
		addMorphFront: (SimpleButtonMorph new target: self; actWhen: #buttonDown; actionSelector:  #saySomething; labelString: 'test').
	answer
		addSliderForParameter: #speed target: self min: 0.1 max: 2.0 description: 'Speed';
		addSliderForParameter: #loudness target: self min: 0.0 max: 1.0 description: 'Loudness';
		addSliderForParameter: #range target: self min: 0.0 max: 1.0 description: 'Pitch Range';
		addSliderForParameter: #pitch target: self min: 20.0 max: 800.0 description: 'Pitch';
		addMorphFront: buttons;
		openInWorld! !

!Speaker methodsFor: 'editing' stamp: 'len 12/2/1999 03:19'!
findAVoice: aClass
	(self voice isKindOf: aClass) ifTrue: [^ self voice].
	(self voice isKindOf: CompositeVoice)
		ifTrue: [self voice do: [ :each | (each isKindOf: aClass) ifTrue: [^ each]]].
	^ nil! !

!Speaker methodsFor: 'editing' stamp: 'len 12/2/1999 03:27'!
makeGestural
	(self findAVoice: GesturalVoice) isNil ifFalse: [^ self].
	self voice: self voice + GesturalVoice new! !

!Speaker methodsFor: 'editing' stamp: 'len 12/2/1999 03:27'!
newHead
	self makeGestural.
	(self findAVoice: GesturalVoice) newHead! !

!Speaker methodsFor: 'editing' stamp: 'len 12/14/1999 05:24'!
saySomething
	self say: #('This is my voice.' 'I am speaking.' 'Do you like my voice?' 'Listen to my voice.' 'Hello.' 'Hay. What are you doing?' 'How are you?' 'Is this my voice?' 'Are you there?' 'Help, please.' 'Howdy.' 'Ha ha he he hi.') atRandom! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Speaker class
	instanceVariableNames: ''!

!Speaker class methodsFor: 'instance creation' stamp: 'len 12/12/1999 23:06'!
new
	^ super new initialize! !


!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:17'!
bicyclic
	"
	Speaker bicyclic say: 'This is my voice. I am a woman with bicyclic voice.'
	"

	^ self new
		pitch: 200.0;
		voice: (KlattVoice new diplophonia: 0.4; tract: 14.4)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:56'!
bigMan
	"
	Speaker bigMan say: 'I am the child? No. I am the big man speaking.'
	"

	^ self new
		pitch: 90.0;
		range: 0.5;
		voice: (KlattVoice new tract: 20)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:19'!
breathy
	"
	Speaker breathy say: 'This is my breathy voice.'
	"

	^ self new
		pitch: 100.0;
		voice: (KlattVoice new ro: 0.6; turbulence: 70)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 04:07'!
child
	"
	Speaker child say: 'Hello. I am a child speaking.'
	"

	^ self new
		pitch: 320.0;
		voice: (KlattVoice new tract: 12)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:21'!
creaky
	"
	Speaker creaky say: 'This is my creaky voice with hight jitter and shimmer.'
	"

	^ self new
		pitch: 90.0;
		speed: 0.5;
		voice: (KlattVoice new jitter: 0.5; shimmer: 0.5)! !

!Speaker class methodsFor: 'examples' stamp: 'len 11/27/2000 10:01'!
default
	"
	Speaker default say: 'This is the default voice.'
	"

	^ self new voice: KlattVoice new! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 04:13'!
exorsist
	"
	Speaker exorsist say: 'This is an scary voice. Boo.'
	"

	^ self new
		pitch: 40.0;
		speed: 0.5;
		voice: (KlattVoice new tract: 10; diplophonia: 0.4; jitter: 0.3; shimmer: 0.5; turbulence: 50)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 04:13'!
fly
	"
	Speaker fly say: 'Haaaaaalp.'
	"

	^ self new
		pitch: 650.0;
		loudness: 0.5;
		speed: 0.8;
		voice: (KlattVoice new flutter: 1.0; tract: 1)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 04:01'!
kid
	"
	Speaker kid say: 'Do you like my voice? I am the kid speaking.'
	"

	^ self new
		pitch: 170.0;
		range: 0.4;
		voice: (KlattVoice new tract: 16)! !

!Speaker class methodsFor: 'examples' stamp: 'len 11/27/2000 10:01'!
man
	"
	Speaker man say: 'Listen to my voice. I am a man speaking.'
	"

	^ self default pitch: 90.0! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:26'!
notPressed
	"
	Speaker notPressed say: 'This is a non pressed voice.'
	"

	^ self new
		pitch: 100.0;
		voice: (KlattVoice new ro: 0.9)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:26'!
pressed
	"
	Speaker pressed say: 'This is a pressed voice.'
	"

	^ self new
		pitch: 100.0;
		voice: (KlattVoice new ro: 0.1)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 03:27'!
whispery
	"
	Speaker whispery say: 'This is my whispery voice.'
	"

	^ self new
		voice: (KlattVoice new breathiness: 1.0)! !

!Speaker class methodsFor: 'examples' stamp: 'len 12/14/1999 04:10'!
woman
	"
	Speaker woman say: 'Do you listen? I am a woman speaking.'
	"

	^ self new
		pitch: 230.0;
		range: 0.5;
		speed: 0.7;
		voice: (KlattVoice new flutter: 0.5; ro: 0.3; ra: 0.003; tract: 14.4)! !


!Speaker class methodsFor: 'examples-others' stamp: 'len 12/2/1999 03:46'!
manWithEditor
	"
	Speaker manWithEditor say: 'With this editor you can change my voice.'
	"

	^ self man edit! !

!Speaker class methodsFor: 'examples-others' stamp: 'len 12/14/1999 05:10'!
manWithHead
	"
	Speaker manWithHead say: 'This is my voice. Can you see my lips?'
	"

	^ self man newHead! !


Object subclass: #Syllable
	instanceVariableNames: 'phonemes accent events '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!
!Syllable commentStamp: '<historical>' prior: 0!
My instances are syllables. They can carry a pitch accent: 'H*', 'L*', etc.!


!Syllable methodsFor: 'accessing' stamp: 'len 12/11/1999 13:03'!
accent
	^ accent! !

!Syllable methodsFor: 'accessing' stamp: 'len 12/11/1999 13:04'!
accent: aString
	accent _ aString! !

!Syllable methodsFor: 'accessing' stamp: 'len 12/8/1999 17:47'!
accept: anObject
	anObject syllable: self! !

!Syllable methodsFor: 'accessing' stamp: 'len 12/13/1999 02:39'!
events
	^ events ifNil: [events _ CompositeEvent new addAll: (self phonemes collect: [ :each | PhoneticEvent new phoneme: each; duration: 0.080]); yourself]! !

!Syllable methodsFor: 'accessing' stamp: 'len 12/8/1999 02:55'!
phonemes
	^ phonemes! !

!Syllable methodsFor: 'accessing' stamp: 'len 12/8/1999 02:55'!
phonemes: aCollection
	phonemes _ aCollection! !

!Syllable methodsFor: 'accessing' stamp: 'len 12/8/1999 02:54'!
stress
	self phonemes do: [ :each | each stress > 0 ifTrue: [^ each stress]].
	^ 0! !


!Syllable methodsFor: 'enumarating' stamp: 'len 12/13/1999 01:20'!
eventsDo: aBlock
	self events do: aBlock! !


!Syllable methodsFor: 'testing' stamp: 'len 12/8/1999 19:03'!
hasPrimaryStress
	^ self stress = 1! !

!Syllable methodsFor: 'testing' stamp: 'len 12/8/1999 19:03'!
hasSecondaryStress
	^ self stress = 2! !

!Syllable methodsFor: 'testing' stamp: 'len 12/11/1999 13:11'!
isAccented
	^ self accent notNil! !


!Syllable methodsFor: 'printing' stamp: 'len 12/8/1999 02:57'!
printOn: aStream
	| first |
	aStream nextPut: $[.
	first _ true.
	self phonemes do: [ :each |
		first ifFalse: [aStream space].
		aStream print: each.
		first _ false].
	aStream nextPut: $]! !


Object subclass: #UtteranceVisitor
	instanceVariableNames: 'clause phrase word syllable '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!

!UtteranceVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 18:53'!
clause: aClause
	clause _ aClause.
	clause phrases do: [ :each | each accept: self].
	phrase _ word _ syllable _ nil! !

!UtteranceVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 18:53'!
phrase: aPhrase
	phrase _ aPhrase.
	phrase words do: [ :each | each accept: self].
	word _ syllable _ nil! !

!UtteranceVisitor methodsFor: 'visiting' stamp: 'len 12/10/1999 02:46'!
speaker: aSpeaker
	^ self! !

!UtteranceVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 16:36'!
syllable: aSyllable
	syllable _ aSyllable! !

!UtteranceVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 18:53'!
word: aWord
	word _ aWord.
	word syllables do: [ :each | each accept: self].
	syllable _ nil! !


UtteranceVisitor subclass: #DurationsVisitor
	instanceVariableNames: 'inherents lowers speed '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!
!DurationsVisitor commentStamp: '<historical>' prior: 0!
This is an implementation of the Klatt rule system as described in chapter 9 of "From text to speech: The MITalk system", Allen, Hunnicutt and Klatt.!


!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:38'!
defaultDurationFor: aPhoneme
	"Some hardcoded durations for phonemes."
	aPhoneme isVoiced ifTrue: [^ 0.0565].
	aPhoneme isUnvoiced ifTrue: [^ 0.0751].
	aPhoneme isConsonant ifTrue: [^ 0.06508].
	aPhoneme isDiphthong ifTrue: [^ 0.1362].
	^ 0.0741! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:39'!
inherentDurationAt: aPhoneme
	^ self inherents at: aPhoneme ifAbsent: [Transcript show: ' default duration for ', aPhoneme name. self defaultDurationFor: aPhoneme]! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:39'!
inherents
	^ inherents! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:39'!
inherents: aDictionary
	inherents _ aDictionary! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:39'!
lowerDurationAt: aPhoneme
	^ self lowers at: aPhoneme ifAbsent: [self inherentDurationAt: aPhoneme]! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:39'!
lowers
	^ lowers! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 16:39'!
lowers: aDictionary
	lowers _ aDictionary! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 18:28'!
speed
	^ speed! !

!DurationsVisitor methodsFor: 'accessing' stamp: 'len 12/8/1999 18:28'!
speed: aNumber
	speed _ aNumber! !


!DurationsVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 04:22'!
clause: aClause
	| min |
	super clause: aClause.

	self rule2.

	clause wordsDo: [ :eachWord |
		eachWord events do: [ :each |
			min _ self lowerDurationAt: each phoneme.
			eachWord isAccented ifFalse: [min _ min / 2.0].
			each duration: each duration + min / 1.4 / self speed]].
	clause syllablesDo: [ :each | each events recomputeTimes]! !

!DurationsVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 17:04'!
phrase: aPhrase
	super phrase: aPhrase.
	self rule3; rule3b! !

!DurationsVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 18:27'!
speaker: aSpeaker
	self speed: aSpeaker speed! !

!DurationsVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 17:05'!
syllable: aSyllable
	super syllable: aSyllable.

	syllable events do: [ :each | each duration: (self inherentDurationAt: each phoneme) - (self lowerDurationAt: each phoneme)].
	self rule4; rule5; rule9a; rule9b; rule10! !

!DurationsVisitor methodsFor: 'visiting' stamp: 'len 12/8/1999 17:06'!
word: aWord
	super word: aWord.

	self rule6; rule7; rule8! !


!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:55'!
rule10
	"Rule 10: Shortening in clusters."
	| current next previous stream |
	phrase lastSyllable == syllable ifTrue: [^ self].
	stream _ ReadStream on: syllable events.
	current _ nil.
	next _ stream next.
	[stream atEnd]
		whileFalse: [previous _ current.
					current _ next.
					next _ stream next.
					current phoneme isVowel
						ifTrue: [next phoneme isVowel
									ifTrue: [current stretch: 1.2]
									ifFalse: [(previous notNil and: [previous phoneme isVowel])
												ifTrue: [current stretch: 0.7]]]
						ifFalse: [next phoneme isConsonant
									ifTrue: [(previous notNil and: [previous phoneme isConsonant])
												ifTrue: [current stretch: 0.5]
												ifFalse: [current stretch: 0.7]]
									ifFalse: [(previous notNil and: [previous phoneme isConsonant])
												ifTrue: [current stretch: 0.5]]]]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:53'!
rule2
	"Rule 2: Clause Final Lengthening."

	clause lastSyllable events stretch: 1.4! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/13/1999 02:36'!
rule3
	"Rule 3: Non-phrase-final shortening.
	Syllabic segments are shortened by 60 if not in a phrase-final syllable."

	phrase syllablesDo: [ :each |
		phrase lastSyllable == each
			ifFalse: [each events do: [ :event | event phoneme isSyllabic ifTrue: [event stretch: 0.6]]]]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:53'!
rule3b
	"A phrase-final postvocalic liquid or nasal is lengthened by 140"

	phrase lastSyllable events do: [ :each | (each phoneme isNasal or: [each phoneme isLiquid]) ifTrue: [each stretch: 1.4]]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:56'!
rule4
	"Rule 4: Non-word-final shortening.
	Syllabic segments are shortened by 85 if not in a word-final syllable."

	word lastSyllable == syllable ifTrue: [^ self].
	syllable events do: [ :each | each phoneme isSyllabic ifTrue: [each stretch: 0.85]]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:56'!
rule5
	"Rule 5: Polysyllabic Shortening.
	Syllabic segments in a polysyllabic word are shortened by 80."

	word isPolysyllabic ifFalse: [^ self].
	syllable events do: [ :each | each phoneme isSyllabic ifTrue: [each stretch: 0.8]]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:59'!
rule6
	"Rule 6: Non-initial-consonant shortening."

	| nonInitial |
	nonInitial _ false.
	word events do: [ :each |
		(nonInitial and: [each phoneme isConsonant]) ifTrue: [each stretch: 0.85].
		nonInitial _ true]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:59'!
rule7
	"Rule 7: Unstressed shortening."

	word syllables
		do: [ :each |
			each stress > 0
				ifFalse: [each events do: [ :event | event phoneme isSyllabic ifTrue: [event stretch: 0.5]].
						each events first phoneme isSyllabic ifTrue: [each events first stretch: 0.7 / 0.5].
						(each events last phoneme isSyllabic and: [each events size > 1]) ifTrue: [each events last stretch: 0.7 / 0.5]]]
! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/13/1999 02:33'!
rule8
	"Rule 8: Lengthening for emphasis."

	word isAccented
		ifTrue: [word events do: [ :each | each phoneme isVowel ifTrue: [each stretch: 1.4]]]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:57'!
rule9a
	"Rule 9a: Postvocalic context of vowels."

	| events current next nextnext |
	phrase lastSyllable == syllable ifTrue: [^ self].
	events _ syllable events.
	1 to: events size do: [ :i |
		current _ events at: i.
		next _ i + 1 <= events size ifTrue: [(events at: i + 1) phoneme].
		nextnext _ i + 2 <= events size ifTrue: [(events at: i + 2) phoneme].
		current stretch: (self rule9a: current phoneme next: next nextnext: nextnext)]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 17:00'!
rule9a: current next: next nextnext: nextnext
	"Rule 9a: Postvocalic context of vowels."

	current isVowel
		ifTrue: [next isNil ifTrue: [^ 1.2].
				nextnext isNil ifTrue: [^ self subRule9a: next].
				(next isSonorant and: [nextnext isObstruent]) ifTrue: [^ self subRule9a: nextnext]]
		ifFalse: [current isSonorant
					ifTrue: [next isNil ifTrue: [^ 1.2].
							next isObstruent ifTrue: [^ self subRule9a: next]]].
	^ 1.0! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 16:58'!
rule9b
	"Rule 9b: Postvocalic context of vowels."

	| events current next nextnext |
	phrase lastSyllable == syllable ifFalse: [^ self].
	events _ syllable events.
	1 to: events size do: [ :i |
		current _ events at: i.
		next _ i + 1 <= events size ifTrue: [(events at: i + 1) phoneme].
		nextnext _ i + 2 <= events size ifTrue: [(events at: i + 2) phoneme].
		current stretch: 0.3 * (self rule9a: current phoneme next: next nextnext: nextnext) + 0.7]! !

!DurationsVisitor methodsFor: 'rules' stamp: 'len 12/8/1999 17:01'!
subRule9a: aPhoneme
	"Sub-rule 9a, independent of segment position."
	aPhoneme isVoiced ifFalse: [^ aPhoneme isStop ifTrue: [0.7] ifFalse: [1.0]].
	aPhoneme isFricative ifTrue: [^ 1.6].
	aPhoneme isStop ifTrue: [^ 1.2].
	aPhoneme isNasal ifTrue: [^ 0.85].
	^ 1.0! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

DurationsVisitor class
	instanceVariableNames: ''!

!DurationsVisitor class methodsFor: 'instance creation' stamp: 'len 12/8/1999 16:40'!
inherents: aDictionary lowers: anotherDictionary
	^ self new inherents: aDictionary; lowers: anotherDictionary! !


!DurationsVisitor class methodsFor: 'examples' stamp: 'len 12/8/1999 16:40'!
default
	| phonemes inherents lowers |
	phonemes _ PhonemeSet arpabet.
	inherents _ Dictionary new.
	lowers _ Dictionary new.
	#(
	('ae'	230.0	80.0)
	('aa'	240.0	100.0)
	('ax'	120.0	60.0)
	('er'	180.0	80.0)
	('ay'	250.0	150.0)
	('aw'	240.0	100.0)
	('b'		85.0		60.0)
	('ch'	70.0		50.0)
	('d'		75.0		50.0)
	('dh'	50.0		30.0)
	('eh'	150.0	70.0)
	('ea'	270.0	130.0)
	('ey'	180.0	100.0)
	('f'		100.0	80.0)
	('g'		80.0		60.0)
	('hh'	80.0		20.0)
	('ih'	135.0	40.0)
	('ia'	230.0	100.0)
	('iy'	155.0	55.0)
	('jh'	70.0		50.0)
	('k'		80.0		60.0)
	('l'		80.0		40.0)
	('m'		70.0		60.0)
	('n'		60.0		50.0)
	('ng'	95.0		60.0)
"	('oh'	240.0	130.0)"
	('oy'	280.0	150.0)
	('ao'	240.0	130.0)
	('ow'	220.0	80.0)
	('p'		90.0		50.0)
	('r'		80.0		30.0)
	('s'		105.0	60.0)
	('sh'	105.0	80.0)
	('t'		75.0		50.0)
	('th'	90.0		60.0)
	('uh'	210.0	70.0)
	('ua'	230.0	110.0)
	('ah'	160.0	60.0)
	('uw'	230.0	150.0)
	('v'		60.0		40.0)
	('w'		80.0		60.0)
	('y'		80.0		40.0)
	('z'		75.0		40.0)
	('zh'	70.0		40.0)
	('sil'	100.0	100.0)) do: [ :each |
		inherents at: (phonemes at: each first) put: each second / 1000.0.
		lowers at: (phonemes at: each first) put: each last / 1000.0].
	^ self inherents: inherents lowers: lowers! !


UtteranceVisitor subclass: #F0RenderingVisitor
	instanceVariableNames: 'pitch range contour '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!

!F0RenderingVisitor methodsFor: 'accessing' stamp: 'len 12/13/1999 03:47'!
highPitch
	^ pitch + (pitch * range)! !

!F0RenderingVisitor methodsFor: 'accessing' stamp: 'len 12/13/1999 03:47'!
lowPitch
	^ pitch - (pitch * range)! !

!F0RenderingVisitor methodsFor: 'accessing' stamp: 'len 12/13/1999 01:21'!
timeForEvent: aVoiceEvent
	| time |
	time _ 0.
	clause eventsDo: [ :each | aVoiceEvent == each ifTrue: [^ time] ifFalse: [time _ time + each duration]]! !


!F0RenderingVisitor methodsFor: 'visiting' stamp: 'len 12/24/1999 03:20'!
clause: aClause
	contour _ CosineInterpolator new at: 0 put: pitch; yourself.

	super clause: aClause.
	self renderPhraseAccentOrBoundaryTone: clause accent.

	self assignF0ToEvents! !

!F0RenderingVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 02:31'!
phrase: aPhrase
	super phrase: aPhrase.

	self renderPhraseAccentOrBoundaryTone: phrase accent! !

!F0RenderingVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 02:41'!
renderPhraseAccentOrBoundaryTone: aStringOrNil
	aStringOrNil isNil ifTrue: [^ self].
	(aStringOrNil findTokens: ' ') do: [ :each |
		each = 'H-' ifTrue: [self renderHighPhraseAccent].
		each = 'L-' ifTrue: [self renderLowPhraseAccent].
		each = 'H%' ifTrue: [self renderHighBoundary].
		each = 'L%' ifTrue: [self renderLowBoundary].
		each = '%H' ifTrue: [self renderHighInitial].
		each = '%r' ifTrue: [self notYetImplemented]]! !

!F0RenderingVisitor methodsFor: 'visiting' stamp: 'len 12/13/1999 02:42'!
speaker: aSpeaker
	pitch _ aSpeaker pitch.
	range _ aSpeaker range! !

!F0RenderingVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 02:41'!
syllable: aSyllable
	super syllable: aSyllable.

	aSyllable isAccented ifFalse: [^ self].
	aSyllable accent = 'H*' ifTrue: [^ self renderPeakAccent].
	aSyllable accent = 'L*' ifTrue: [^ self renderLowAccent].
	aSyllable accent = 'L*+H' ifTrue: [^ self renderScoopedAccent].
	aSyllable accent = 'L+H*' ifTrue: [^ self renderRisingPeakAccent]! !


!F0RenderingVisitor methodsFor: 'rendering-pitch accents' stamp: 'len 12/14/1999 05:47'!
renderLowAccent
	"Render a L* accent."
	| start stop peakPosition |
	start _ self syllableStartTime.
	stop _ self syllableStopTime.
	peakPosition _ (syllable events detect: [ :one | one phoneme isSyllabic] ifNone: [syllable events first]) duration / 2.0.
	self time: start
		startingF0: (contour at: start)
		amplitude: (contour at: start) - self lowPitch
		duration: stop - start
		peakPosition: peakPosition
		tilt: 0.0! !

!F0RenderingVisitor methodsFor: 'rendering-pitch accents' stamp: 'len 12/14/1999 05:47'!
renderPeakAccent
	"Render a H* accent."
	| start stop peakPosition |
	start _ self syllableStartTime.
	stop _ self syllableStopTime.
	peakPosition _ (syllable events detect: [ :one | one phoneme isSyllabic] ifNone: [syllable events first]) duration / 2.0.
	self time: start
		startingF0: (contour at: start)
		amplitude: self highPitch - (contour at: start)
		duration: stop - start
		peakPosition: peakPosition
		tilt: 0.0! !

!F0RenderingVisitor methodsFor: 'rendering-pitch accents' stamp: 'len 12/14/1999 01:44'!
renderRisingPeakAccent
	"Render a L+H* accent."

	self notYetImplemented! !

!F0RenderingVisitor methodsFor: 'rendering-pitch accents' stamp: 'len 12/14/1999 01:45'!
renderScoopedAccent
	"Render a L*+H accent."

	self notYetImplemented! !

!F0RenderingVisitor methodsFor: 'rendering-pitch accents' stamp: 'len 12/14/1999 01:43'!
syllableStartTime
	^ self timeForEvent: syllable events first! !

!F0RenderingVisitor methodsFor: 'rendering-pitch accents' stamp: 'len 12/14/1999 01:43'!
syllableStopTime
	^ self syllableStartTime + syllable events duration! !


!F0RenderingVisitor methodsFor: 'rendering-phrase accents' stamp: 'len 12/14/1999 03:45'!
phraseAccentStartTime
	| syl |
	syl _ nil.
	(phrase ifNil: [clause phrases last]) syllablesDo: [ :each | (syl isNil or: [syl isAccented]) ifTrue: [syl _ each]].
	^ self timeForEvent: syl events last! !

!F0RenderingVisitor methodsFor: 'rendering-phrase accents' stamp: 'len 12/14/1999 01:17'!
phraseAccentStopTime
	| lastEvent |
	lastEvent _ (phrase ifNil: [clause phrases last]) lastSyllable events last.
	^ (self timeForEvent: lastEvent) + lastEvent duration! !

!F0RenderingVisitor methodsFor: 'rendering-phrase accents' stamp: 'len 12/14/1999 01:23'!
renderHighPhraseAccent
	"Render a H- accent."
	| start stop |
	start _ self phraseAccentStartTime.
	stop _ self phraseAccentStopTime.
	self time: start
		startingF0: (contour at: start)
		amplitude: self highPitch - (contour at: start)
		duration: stop - start
		peakPosition: stop - start
		tilt: 1.0! !

!F0RenderingVisitor methodsFor: 'rendering-phrase accents' stamp: 'len 12/14/1999 03:48'!
renderLowPhraseAccent
	"Render a L- accent."
	| start stop |
	start _ self phraseAccentStartTime.
	stop _ self phraseAccentStopTime.
	self time: start
		startingF0: (contour at: start)
		amplitude: (contour at: start) - self lowPitch
		duration: stop - start
		peakPosition: stop - start
		tilt: -0.5! !


!F0RenderingVisitor methodsFor: 'rendering-boundary tones' stamp: 'len 12/14/1999 02:27'!
boundaryStartTime
	^ self timeForEvent: (phrase ifNil: [clause phrases last]) words last events first! !

!F0RenderingVisitor methodsFor: 'rendering-boundary tones' stamp: 'len 12/14/1999 02:27'!
boundaryStopTime
	| lastEvent |
	lastEvent _ (phrase ifNil: [clause phrases last]) lastSyllable events last.
	^ (self timeForEvent: lastEvent) + lastEvent duration! !

!F0RenderingVisitor methodsFor: 'rendering-boundary tones' stamp: 'len 12/14/1999 01:38'!
initialStopTime
	| lastEvent |
	lastEvent _ 	clause phrases first words first lastSyllable events last.
	^ (self timeForEvent: lastEvent) + lastEvent duration! !

!F0RenderingVisitor methodsFor: 'rendering-boundary tones' stamp: 'len 12/14/1999 01:34'!
renderHighBoundary
	"Render a H% boundary tone."
	| start stop |
	start _ self boundaryStartTime.
	stop _ self boundaryStopTime.
	self time: start
		startingF0: (contour at: start)
		amplitude: self highPitch - (contour at: start)
		duration: stop - start
		peakPosition: stop - start
		tilt: 1.0! !

!F0RenderingVisitor methodsFor: 'rendering-boundary tones' stamp: 'len 12/14/1999 03:07'!
renderHighInitial
	"Render a %H tone."
	| start stop |
	start _ 0.
	stop _ self initialStopTime.
	self time: start
		startingF0: (contour at: start)
		amplitude: self highPitch - (contour at: start) * 2
		duration: stop - start
		peakPosition: start
		tilt: 0.0! !

!F0RenderingVisitor methodsFor: 'rendering-boundary tones' stamp: 'len 12/14/1999 03:44'!
renderLowBoundary
	"Render a L% boundary tone."
	| start stop |
	start _ self boundaryStartTime.
	stop _ self boundaryStopTime.
	self time: start
		startingF0: (contour at: start)
		amplitude: (contour at: start) - self lowPitch
		duration: stop - start
		peakPosition: stop - start
		tilt: -1.0! !


!F0RenderingVisitor methodsFor: 'private' stamp: 'len 12/14/1999 00:48'!
assignF0ToEvents
	| time |
	time _ 0.
	clause events do: [ :each |
		each pitchPoints: (self pitchesBetween: time and: time + each duration).
		time _ time + each duration]! !

!F0RenderingVisitor methodsFor: 'private' stamp: 'len 12/13/1999 02:55'!
pitchesBetween: t1 and: t2
	| step |
	step _ (t2 - t1 / 0.035) asInteger + 1. "step small enough"
	^ (t1 to: t2 by: t2 - t1 / step) collect: [ :each | each - t1 @ (contour at: each)]! !

!F0RenderingVisitor methodsFor: 'private' stamp: 'len 12/14/1999 03:47'!
time: time startingF0: startingF0 amplitude: amplitude duration: duration peakPosition: peakPosition tilt: tilt
	| vowelStart riseAmplitude fallAmplitude |
	vowelStart _ self timeOfFirstVowelAfter: time.
	riseAmplitude _ tilt + 1.0 * amplitude / 2.0.
	fallAmplitude _ amplitude - riseAmplitude.
	contour
		x: time y: startingF0;
		x: vowelStart + peakPosition y: ((startingF0 + riseAmplitude max: self lowPitch) min: self highPitch);
		x: time + duration y: ((startingF0 + riseAmplitude - fallAmplitude max: self lowPitch) min: self highPitch);
		commit! !

!F0RenderingVisitor methodsFor: 'private' stamp: 'len 12/14/1999 01:47'!
timeOfFirstVowelAfter: time
	| currentTime |
	currentTime _ 0.
	clause events do: [ :each |
		(currentTime >= time and: [each phoneme isSyllabic]) ifTrue: [^ currentTime].
		currentTime _ currentTime + each duration].
	^ time "if not found, answer the time itself"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

F0RenderingVisitor class
	instanceVariableNames: ''!

!F0RenderingVisitor class methodsFor: 'examples' stamp: 'len 12/13/1999 02:25'!
default
	^ self new! !


UtteranceVisitor subclass: #IntonationVisitor
	instanceVariableNames: 'functionWords '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!

!IntonationVisitor methodsFor: 'accessing' stamp: 'len 12/10/1999 02:45'!
functionWords
	^ functionWords! !

!IntonationVisitor methodsFor: 'accessing' stamp: 'len 12/10/1999 02:45'!
functionWords: aCollection
	functionWords _ aCollection! !


!IntonationVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 02:52'!
clause: aClause
	super clause: aClause.

	self isYesNoQuestionClause ifTrue: [^ clause accent: 'L- H%'].
	self isWHQuestionClause ifTrue: [^ clause accent: '%H H- L%'].
	clause accent: 'L- L%' "it's a declarative phrase"! !

!IntonationVisitor methodsFor: 'visiting' stamp: 'len 12/12/1999 22:44'!
isQuestionClause
	^ clause string includes: $?! !

!IntonationVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 00:07'!
isWHQuestionClause
	| firstWordString |
	self isQuestionClause ifFalse: [^ false].
	firstWordString _ clause phrases first words first string asLowercase.
	^ (firstWordString beginsWith: 'wh') or: [firstWordString = 'how']! !

!IntonationVisitor methodsFor: 'visiting' stamp: 'len 12/12/1999 22:45'!
isYesNoQuestionClause
	^ self isQuestionClause and: [self isWHQuestionClause not]! !

!IntonationVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 03:16'!
phrase: aPhrase
	super phrase: aPhrase.

"	phrase == clause phrases last ifFalse: [phrase accent: 'L- H%']"! !

!IntonationVisitor methodsFor: 'visiting' stamp: 'len 12/14/1999 03:12'!
word: aWord
	| accent |
	super word: aWord.

	((self functionWords includes: word string asLowercase) and: [phrase words first ~~ word]) ifTrue: [^ self].
	self isYesNoQuestionClause ifTrue: [accent _ 'L*'] ifFalse: [accent _ 'H*'].
	(word syllables detect: [ :one | one stress > 0] ifNone: [word syllables first]) accent: accent! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

IntonationVisitor class
	instanceVariableNames: ''!

!IntonationVisitor class methodsFor: 'examples' stamp: 'len 12/13/1999 02:25'!
default
	^ self english! !

!IntonationVisitor class methodsFor: 'examples' stamp: 'len 12/10/1999 02:41'!
english
	^ self new functionWords: self englishFunctionWords! !

!IntonationVisitor class methodsFor: 'examples' stamp: 'len 12/10/1999 02:41'!
englishFunctionWords
	^ #('a' 'about' 'above' 'across' 'after' 'ago' 'all' 'along' 'although' 'am' 'among'
		'an' 'and' 'any' 'apart' 'are' 'aren''t' 'around' 'as' 'aside' 'at' 'away'
		'back' 'be' 'because' 'been' 'before' 'behind' 'below' 'between' 'both'
		'but' 'by' 'can' 'can''t' 'could' 'couldn''t' 'down' 'each' 'either' 'every'
		'few' 'for' 'forever' 'forward' 'fro' 'from' 'has' 'hasn''t' 'have' 'haven''t'
		'he' 'her' 'here' 'him' 'his' 'home' 'how' 'however' 'i' 'if' 'immediately'
		'in' 'inside' 'is' 'it' 'its' 'least' 'less' 'like' 'little' 'many' 'more' 'most' 'much'
		'my' 'neither' 'no' 'none' 'nor' 'not' 'now' 'of' 'off' 'on' 'once' 'only' 'or'
		'our' 'out' 'outside' 'over' 'part' 'plenty' 'right' 'round' 'several' 'she'
		'should' 'shouldn''t' 'since' 'so' 'some' 'than' 'that' 'the' 'their' 'theirs'
		'then' 'there' 'these' 'they' 'this' 'those' 'though' 'through' 'till' 'to' 'together'
		'unless' 'until' 'up' 'upon' 'was' 'wasn''t' 'we' 'were' 'weren''t' 'what'
		'whatever' 'when' 'where' 'whereas' 'whether' 'which' 'while' 'who' 'whom'
		'whose' 'why' 'will' 'with' 'without' 'would' 'wouldn''t' 'yet' 'you' 'your' 'yours'
	) asSet! !


Object subclass: #Word
	instanceVariableNames: 'string syllables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Speech-TTS'!

!Word methodsFor: 'accessing' stamp: 'len 12/8/1999 17:47'!
accept: anObject
	anObject word: self! !

!Word methodsFor: 'accessing' stamp: 'len 12/8/1999 17:53'!
events
	| answer |
	answer _ CompositeEvent new.
	self syllables do: [ :each | answer addAll: each events].
	^ answer! !

!Word methodsFor: 'accessing' stamp: 'len 12/13/1999 02:33'!
lastSyllable
	^ self syllables last! !

!Word methodsFor: 'accessing' stamp: 'len 12/8/1999 17:49'!
string
	^ string! !

!Word methodsFor: 'accessing' stamp: 'len 12/8/1999 17:49'!
string: aString
	string _ aString! !

!Word methodsFor: 'accessing' stamp: 'len 12/8/1999 17:48'!
syllables
	^ syllables! !

!Word methodsFor: 'accessing' stamp: 'len 12/8/1999 17:48'!
syllables: aCollection
	syllables _ aCollection! !


!Word methodsFor: 'enumerating' stamp: 'len 12/13/1999 01:20'!
eventsDo: aBlock
	self syllables do: [ :syllable | syllable eventsDo: aBlock]! !


!Word methodsFor: 'testing' stamp: 'len 12/11/1999 13:11'!
isAccented
	^ (self syllables detect: [ :one | one isAccented] ifNone: []) notNil! !

!Word methodsFor: 'testing' stamp: 'len 12/8/1999 18:47'!
isPolysyllabic
	^ self syllables size > 1! !


!Word methodsFor: 'printing' stamp: 'len 12/13/1999 03:18'!
printOn: aStream
	aStream nextPutAll: (self isAccented ifTrue: [self string asUppercase] ifFalse: [self string])! !
